unit USearchTreeNode;

interface
uses classes,dialogs,UTreeNode,USortElement;

type TSearchTreeNode = class(TTreeNode)
       private
         function max:TSearchTreeNode;
         procedure deleteRoot;
       public
         procedure insert(Elem: TSortElement);
         procedure delete(Elem: TSortElement);
         function isElement(Elem: TSortElement) : Boolean;
         function search(Elem: TSortElement) : TSearchTreeNode;
       end;

implementation

procedure TSearchTreeNode.insert(Elem: TSortElement);
begin
   if isempty then
      Writevalue(Elem)
   else
      if Elem.GreaterThan(TSortElement(ReadValue)) then
         TSearchTreeNode(ReadRightNode).insert(Elem)
      else
         TSearchTreeNode(ReadLeftNode).insert(Elem)
end;

function TSearchTreeNode.iselement(Elem: TSortElement):Boolean;
begin
   if isempty then
      result := false
   else
      if Elem.Equal(TSortElement(Self.ReadValue)) then
         result := true
      else
         if Elem.GreaterThan(TSortElement(Self.ReadValue)) then
            result := TSearchTreeNode(Self.ReadRightNode).isElement(Elem)
         else
            result := TSearchTreeNode(Self.ReadLeftNode).isElement(Elem)
end;

function TSearchTreeNode.Search(Elem: TSortElement):TSearchTreeNode;
begin
   if isempty then
      result := Self
   else
      if Elem.Equal(TSortElement(Self.ReadValue)) then
         result := Self
      else
         if Elem.GreaterThan(TSortElement(Self.ReadValue)) then
            result := TSearchTreeNode(Self.ReadRightNode).Search(Elem)
         else
            result := TSearchTreeNode(Self.ReadLeftNode).Search(Elem)
end;

function TSearchTreeNode.max:TSearchTreeNode;
begin
   if Self.ReadRightNode.isempty then
      result := Self
   else
      result := TSearchTreeNode(Self.readRightNode).max
end;

procedure TSearchTreeNode.deleteRoot;
var ersatz,links,rechts:TTreenode;
begin
   if Self.isLeaf then begin
      showmessage('Lsche '+TSortElement(Self.ReadValue).GetText+' --> Blatt');
      Self.makenil
      end
   else
      if Self.ReadRightNode.isempty then begin
         showmessage('Lsche '+TSortElement(Self.ReadValue).GetText+
                     ' --> Rechter Teilbaum ist leer.');
         links := Self.ReadLeftNode.ReadLeftNode;
         rechts:= Self.ReadLeftNode.ReadRightNode;
         Self.WriteValue(Self.ReadLeftNode.ReadValue);
         Self.WriteLeftNode(links);
         Self.WriteRightNode(rechts)
         end
      else
         if Self.ReadLeftNode.isempty then begin
            showmessage('Lsche '+TSortElement(Self.ReadValue).GetText+
                        ' --> linker Teilbaum ist leer.');
            links := Self.ReadRightNode.ReadLeftNode;
            rechts:= Self.ReadRightNode.ReadRightNode;
            Self.WriteValue(Self.ReadRightNode.ReadValue);
            Self.WriteLeftNode(links);
            Self.WriteRightNode(rechts)
            end
         else begin
            showmessage('Lsche '+TSortElement(Self.ReadValue).GetText+
                        ' --> Lschen durch Ersetzen');
            ersatz := TSearchTreeNode(Self.ReadLeftNode).max;
            showmessage('Ersatz : '+TSortElement(ersatz.ReadValue).GetText);
            Self.WriteValue(ersatz.ReadValue);
            TSearchTreeNode(Self.ReadLeftNode).delete(TSortElement(ersatz.ReadValue))
         end;
end;

procedure TSearchTreeNode.delete(Elem: TSortElement);
Var delNode : TSearchTreeNode;
begin
   delNode := Self.Search(Elem);
   if delNode.isempty
      then showmessage('Knoten nicht vorhanden')
      else delNode.deleteRoot
end;

end.
