unit UTreeNode;

interface

uses Dialogs,classes;

type TTreeNode = class(TObject)
       private
         ValueP : TObject;
         LeftP  : TTreeNode;
         RightP : TTreeNode;
       public
         constructor Create;
         destructor destroy;                         override;
         procedure makenil;
         procedure WriteLeftNode  (node: TTreeNode);
         procedure WriteRightNode (node: TTreeNode);
         procedure WriteValue (Elem: TObject);
         function  ReadLeftNode: TTreeNode;
         function  ReadRightNode: TTreeNode;
         function  ReadValue: TObject;
         function  isEmpty :Boolean;
         function  IsLeaf: Boolean;
     end;

implementation

constructor TTreeNode.create;
begin
  inherited create;
  ValueP := nil;
  LeftP  := nil;
  RightP := nil;
end;

procedure TTreeNode.makenil;
begin
  ValueP := nil;
  LeftP  := nil;
  RightP := nil;
end;

destructor TTreeNode.destroy;
begin
  if not isempty then begin
    if LeftP <> nil then LeftP.destroy;
    if RightP <> nil then RightP.destroy;
  end;
  inherited destroy
end;

procedure TTreeNode.WriteLeftNode (node: TTreeNode);
begin
  if not isempty then
  LeftP := node
end;

procedure TTreeNode.WriteRightNode (node: TTreeNode);
begin
  if not isempty then
  RightP := node
end;

function TTreeNode.ReadLeftNode: TTreeNode;
begin
  if not isempty then
     result := LeftP
  else
     result := self
end;

function TTreeNode.ReadRightNode: TTreeNode;
begin
  if not isempty then
     result := RightP
  else
     result := self   
end;

function TTreeNode.ReadValue: TObject;
begin
  result := ValueP
end;

procedure TTreeNode.WriteValue (Elem: TObject);
begin
  if isempty then begin
     LeftP := TTreeNode.Create;
     RightP := TTreeNode.Create;
     ValueP := Elem;
  end else
     ValueP := Elem
end;

function TTreeNode.IsEmpty: Boolean;
begin
  result := (ValueP=nil)
end;

function TTreeNode.IsLeaf: Boolean;
begin
  if isempty then
     result := false
  else
     result := (LeftP.ValueP=nil) and (RightP.ValueP=nil)
end;

end.

