unit UVerwaltung;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,ExtCtrls,
  UTreeNode,USearchTreeNode,UBasisobjekte, USortElement;
  
type
  TFVerwaltung = class(TForm)
    BtKnotenLoeschen: TButton;
    KnotenEinfuegen: TButton;
    BtNeuerSuchBaum: TButton;
    ListBox1: TListBox;
    EdKnoten: TEdit;
    LbKnoten: TLabel;
    BtKnotenSuchen: TButton;
    RadioGroup1: TRadioGroup;
    RBText: TRadioButton;
    RBGraphik: TRadioButton;
    ImBaum: TImage;
    Label1: TLabel;
    EdKnotenzahl: TEdit;
    procedure BtNeuerSuchBaumClick(Sender: TObject);
    procedure KnotenEinfuegenClick(Sender: TObject);
    procedure BtKnotenSuchenClick(Sender: TObject);
    procedure BtKnotenLoeschenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RBTextClick(Sender: TObject);
    procedure RBGraphikClick(Sender: TObject);
  private
    Suchbaum: TSearchTreeNode;
    procedure SuchbaumAnzeigen (AktKnoten: TTreeNode; Tiefe: integer);
    procedure BaumgraphAnzeigen (AktKnoten:TTreeNode; Tiefe,X,DX: integer);
  public
    { Public-Deklarationen }
  end;

var FVerwaltung: TFVerwaltung;


(***************************************************************************)

implementation

{$R *.DFM}

procedure TFVerwaltung.SuchbaumAnzeigen (AktKnoten:TTreeNode; Tiefe:integer);
var i: integer;
    Leer: string;
    Inhalt: TString;
begin
 if not (AktKnoten.isempty)
    then begin
      SuchBaumAnzeigen (AktKnoten.ReadRightNode,Tiefe+2);
      Leer := '';
      For i := 1 to Tiefe do
        Leer := Leer + ' ';
      Listbox1.items.add (leer+TString(AktKnoten.ReadValue).GetText);
      SuchBaumAnzeigen (AktKnoten.ReadLeftNode,Tiefe+2);
    end
end;

procedure TFVerwaltung.BaumgraphAnzeigen (AktKnoten:TtreeNode; Tiefe,X,DX: integer);
var Inhalt: TSortElement;
    XPos,YPos: integer;
begin
  if not AktKnoten.IsEmpty
    then begin
      DX := DX div 2;
      XPos := X;
      YPos := Tiefe*30 + 20;
      if not AktKnoten.ReadRightNode.isEmpty
      then begin
        ImBaum.Canvas.MoveTo (XPos+7,YPos);
        ImBaum.Canvas.LineTo (XPos+7+DX,YPos+30);
      end;
      BaumgraphAnzeigen (AktKnoten.ReadRightNode,Tiefe+1,X+DX,DX);
      if not AktKnoten.ReadLeftNode.IsEmpty
      then begin
        ImBaum.Canvas.MoveTo (XPos+7,YPos);
        ImBaum.Canvas.LineTo (XPos+7-DX,YPos+30);
      end;
      Inhalt := TSortElement(AktKnoten.ReadValue);
      ImBaum.Canvas.Ellipse (XPos-10,YPos-5,XPos+24,YPos+15);
      ImBaum.Canvas.TextOut (XPos,YPos-3,Inhalt.GetText);
      BaumGraphAnzeigen (AktKnoten.ReadLeftNode,Tiefe+1,X-DX,DX);
    end
end;

procedure TFVerwaltung.BtNeuerSuchBaumClick(Sender: TObject);
Var    NeuInhalt: TString;
       i        : Integer;
begin
  SuchBaum := TSearchTreeNode.Create;
  NeuInhalt := TString.Create('60');
  Suchbaum.Insert(NeuInhalt);
  for i := 1 to StrToInt(EdKnotenzahl.text)-1 do begin
     NeuInhalt := TString.Create(IntToStr(10+ random(90)));
     Suchbaum.Insert(NeuInhalt);
  end;
  Caption := 'Fertig ... !';
  if RBText.Checked
     then RBTextClick(nil)
     else RBGraphikClick(nil)
end;

procedure TFVerwaltung.KnotenEinfuegenClick(Sender: TObject);
var NeuInhalt: TString;
begin
  NeuInhalt := TString.Create(EdKnoten.Text);
  Suchbaum.Insert(NeuInhalt);
  Caption := EdKnoten.Text+' eingefgt';
  if RBText.Checked
     then RBTextClick(nil)
     else RBGraphikClick(nil)
end;

procedure TFVerwaltung.BtKnotenSuchenClick(Sender: TObject);
var SuchInhalt: TString;
begin
  SuchInhalt := TString.Create(EdKnoten.Text);
  if Suchbaum.IsElement (SuchInhalt)
    then Caption := 'Knoten ' + EdKnoten.Text + ' vorhanden'
    else Caption := 'Knoten ' + EdKnoten.Text + ' nicht vorhanden';
  SuchInhalt.Destroy;
end;

procedure TFVerwaltung.BtKnotenLoeschenClick(Sender: TObject);
var Loeschknoten: TString;
   i: integer;
begin
  Loeschknoten := TString.Create(EdKnoten.Text);
  Suchbaum.Delete (Loeschknoten);
  Loeschknoten.Destroy;
  Caption := EdKnoten.Text+' wurde gelscht.';
  if RBText.Checked
     then RBTextClick(nil)
     else RBGraphikClick(nil)
end;

procedure TFVerwaltung.FormCreate(Sender: TObject);
begin
  randomize;
  BtNeuerSuchBaumClick(Sender);
end;

procedure TFVerwaltung.RBTextClick(Sender: TObject);
begin
   ListBox1.Items.Clear;
   ImBaum.visible := False;
   Listbox1.visible := true;
   SuchbaumAnzeigen (Suchbaum,0);
end;

procedure TFVerwaltung.RBGraphikClick(Sender: TObject);
begin
   ImBaum.canvas.rectangle(0,0,ImBaum.width,ImBaum.height);
   ImBaum.visible := True;
   Listbox1.visible := False;
   BaumGraphAnzeigen (Suchbaum,0,ImBaum.Width div 2,
                      ImBaum.Width div 2)
end;

end.          
